-- Brundavo/Fredzaza --

Antos = {};
Antos.ModDirectory = g_currentModDirectory

function Antos.prerequisitesPresent(specializations)
      return true;
end;
function Antos.initSpecialization()
end
function Antos.registerOverwrittenFunctions(vehicleType)
end
function Antos.registerFunctions(vehicleType)	
end
function Antos.registerEvents(vehicleType)
end
function Antos:registerActionEventsPlayer()
end
function Antos:registerActionEventsMenu()
end

function Antos:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
		if self.Antos == nil then 
			self.Antos = {}
		else	
			self:clearActionEventsTable( self.Antos )
		end 
		for _,actionName in pairs({"Patins_Antos","Ridelle_G","Ridelle_D","Ridelle_AR"}) do
			local _, eventName = self:addActionEvent(self.Antos, InputAction[actionName], self, Antos.actionCallback, true, true, false, true, nil);
	
			if isSelected then
				g_inputBinding.events[eventName].displayPriority = 1
			end
		end
	end
end

function Antos.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", Antos)
	SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", Antos)
	SpecializationUtil.registerEventListener(vehicleType, "saveToXMLFile", Antos)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", Antos)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", Antos)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", Antos)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", Antos)
    --SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", Antos)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", Antos)
	SpecializationUtil.registerEventListener(vehicleType, "onDeactivate", Antos)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", Antos)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", Antos)
end

function Antos:onLoad(vehicle)	
	self.Patins_Antos = Antos.Patins_Antos
	self.Ridelle_G = Antos.Ridelle_G
	self.Ridelle_D = Antos.Ridelle_D
	self.Ridelle_AR = Antos.Ridelle_AR
	self.PatinsAntos = false
	self.RidelleG = false
	self.RidelleD = false
	self.RidelleAR = false
	
end;

function Antos:onPostLoad(savegame)
        local PatinsAntos = 0
		local RidelleG = 0
		local RidelleD = 0
		local RidelleAR = 0
        if savegame ~= nil then
            PatinsAntos = getXMLInt(savegame.xmlFile, savegame.key..".Antos#PatinsAntos") or PatinsAntos
        end
		if savegame ~= nil then
            RidelleG = getXMLInt(savegame.xmlFile, savegame.key..".Antos#RidelleG") or RidelleG
        end
		if savegame ~= nil then
            RidelleD = getXMLInt(savegame.xmlFile, savegame.key..".Antos#RidelleD") or RidelleD
        end
		if savegame ~= nil then
            RidelleAR = getXMLInt(savegame.xmlFile, savegame.key..".Antos#RidelleAR") or RidelleAR
        end
		if PatinsAntos == 0 then
            self.PatinsAntos = false
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Patins_Antos", -1000, nil, true)
			end
		else
			self.PatinsAntos = true
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Patins_Antos", 1000, nil, true)
			end
        end
		if RidelleG == 0 then
            self.RidelleG = false
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_G", -1000, nil, true)
			end
		else
			self.RidelleG = true
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_G", 1000, nil, true)
			end
        end
		if RidelleD == 0 then
            self.RidelleD = false
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_D", -1000, nil, true)
			end
		else
			self.RidelleD = true
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_D", 1000, nil, true)
			end
        end
		if RidelleAR == 0 then
            self.RidelleAR = false
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_AR", -1000, nil, true)
			end
		else
			self.RidelleAR = true
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_AR", 1000, nil, true)
			end
        end
end

function Antos:saveToXMLFile(xmlFile, key, usedModNames)

	if self.PatinsAntos then
        setXMLInt(xmlFile, key.."#PatinsAntos", 1)
	else	
		setXMLInt(xmlFile, key.."#PatinsAntos", 0)
	end
	if self.RidelleG then
        setXMLInt(xmlFile, key.."#RidelleG", 1)
	else	
		setXMLInt(xmlFile, key.."#RidelleG", 0)
	end
	if self.RidelleD then
        setXMLInt(xmlFile, key.."#RidelleD", 1)
	else	
		setXMLInt(xmlFile, key.."#RidelleD", 0)
	end
	if self.RidelleAR then
        setXMLInt(xmlFile, key.."#RidelleAR", 1)
	else	
		setXMLInt(xmlFile, key.."#RidelleAR", 0)
	end
end

function Antos:onDelete() 
end;
function Antos:onReadStream(streamId, connection)   
end;  
function Antos:onWriteStream(streamId, connection)  
end;
function Antos:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Antos:keyEvent(unicode, sym, modifier, isDown)    
end;
function Antos:onUpdate(dt, vehicle)		
end;
function Antos:onUpdateTick() 
end;	
function Antos:onDeactivate()	
end;       
function Antos:onDraw()  
end;

function Antos:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
	if keyStatus > 0 then
		if actionName == 'Patins_Antos' then
			if self.PatinsAntos then
				self:Patins_Antos(false)
			else 
				self:Patins_Antos(true)
			end
		end
		if actionName == 'Ridelle_G' then
			if self.RidelleG then
				self:Ridelle_G(false)
			else 
				self:Ridelle_G(true)
			end
		end
		if actionName == 'Ridelle_D' then
			if self.RidelleD then
				self:Ridelle_D(false)
			else 
				self:Ridelle_D(true)
			end
		end
		if actionName == 'Ridelle_AR' then
			if self.RidelleAR then
				self:Ridelle_AR(false)
			else 
				self:Ridelle_AR(true)
			end
		end
	end
end

function Antos:Patins_Antos(PatinsAntos, noEventSend)
	Patins_AntosEvent.sendEvent(self, PatinsAntos, noEventSend)
	self.PatinsAntos = PatinsAntos;
		if self.PatinsAntos then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Patins_Antos", 0.2, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Patins_Antos", -0.2, nil, true)
			end
		end;
end;

function Antos:Ridelle_G(RidelleG, noEventSend)
	Ridelle_GEvent.sendEvent(self, RidelleG, noEventSend)
	self.RidelleG = RidelleG;
		if self.RidelleG then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_G", 0.2, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_G", -0.2, nil, true)
			end
		end;
end;

function Antos:Ridelle_D(RidelleD, noEventSend)
	Ridelle_DEvent.sendEvent(self, RidelleD, noEventSend)
	self.RidelleD = RidelleD;
		if self.RidelleD then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_D", 0.2, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_D", -0.2, nil, true)
			end
		end;
end;

function Antos:Ridelle_AR(RidelleAR, noEventSend)
	Ridelle_AREvent.sendEvent(self, RidelleAR, noEventSend)
	self.RidelleAR = RidelleAR;
		if self.RidelleAR then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_AR", 0.2, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("Ridelle_AR", -0.2, nil, true)
			end
		end;
end;

--- Event ---

Patins_AntosEvent = {};
Patins_AntosEvent_mt = Class(Patins_AntosEvent, Event);
InitEventClass(Patins_AntosEvent, "Patins_AntosEvent");

function Patins_AntosEvent:emptyNew()
    local self = Event:new(Patins_AntosEvent_mt);
    return self;
end;
function Patins_AntosEvent:new(object, PatinsAntos)
	local self = Patins_AntosEvent:emptyNew()
	self.object = object;
	self.PatinsAntos = PatinsAntos;
	return self;
end;
function Patins_AntosEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.PatinsAntos = streamReadBool(streamId);
	self:run(connection);
end;
function Patins_AntosEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.PatinsAntos);
end;
function Patins_AntosEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Patins_Antos(self.PatinsAntos, true);
	end;
end;
function Patins_AntosEvent.sendEvent(vehicle, PatinsAntos, noEventSend)
	if PatinsAntos ~= vehicle.PatinsAntos then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Patins_AntosEvent:new(vehicle, PatinsAntos), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Patins_AntosEvent:new(vehicle, PatinsAntos));
			end;
		end;
	end;
end;


Ridelle_GEvent = {};
Ridelle_GEvent_mt = Class(Ridelle_GEvent, Event);
InitEventClass(Ridelle_GEvent, "Ridelle_GEvent");

function Ridelle_GEvent:emptyNew()
    local self = Event:new(Ridelle_GEvent_mt);
    return self;
end;
function Ridelle_GEvent:new(object, RidelleG)
	local self = Ridelle_GEvent:emptyNew()
	self.object = object;
	self.RidelleG = RidelleG;
	return self;
end;
function Ridelle_GEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.RidelleG = streamReadBool(streamId);
	self:run(connection);
end;
function Ridelle_GEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.RidelleG);
end;
function Ridelle_GEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Ridelle_G(self.RidelleG, true);
	end;
end;
function Ridelle_GEvent.sendEvent(vehicle, RidelleG, noEventSend)
	if RidelleG ~= vehicle.RidelleG then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Ridelle_GEvent:new(vehicle, RidelleG), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Ridelle_GEvent:new(vehicle, RidelleG));
			end;
		end;
	end;
end;


Ridelle_DEvent = {};
Ridelle_DEvent_mt = Class(Ridelle_DEvent, Event);
InitEventClass(Ridelle_DEvent, "Ridelle_DEvent");

function Ridelle_DEvent:emptyNew()
    local self = Event:new(Ridelle_DEvent_mt);
    return self;
end;
function Ridelle_DEvent:new(object, RidelleD)
	local self = Ridelle_DEvent:emptyNew()
	self.object = object;
	self.RidelleD = RidelleD;
	return self;
end;
function Ridelle_DEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.RidelleD = streamReadBool(streamId);
	self:run(connection);
end;
function Ridelle_DEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.RidelleD);
end;
function Ridelle_DEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Ridelle_D(self.RidelleD, true);
	end;
end;
function Ridelle_DEvent.sendEvent(vehicle, RidelleD, noEventSend)
	if RidelleD ~= vehicle.RidelleD then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Ridelle_DEvent:new(vehicle, RidelleD), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Ridelle_DEvent:new(vehicle, RidelleD));
			end;
		end;
	end;
end;


Ridelle_AREvent = {};
Ridelle_AREvent_mt = Class(Ridelle_AREvent, Event);
InitEventClass(Ridelle_AREvent, "Ridelle_AREvent");

function Ridelle_AREvent:emptyNew()
    local self = Event:new(Ridelle_AREvent_mt);
    return self;
end;
function Ridelle_AREvent:new(object, RidelleAR)
	local self = Ridelle_AREvent:emptyNew()
	self.object = object;
	self.RidelleAR = RidelleAR;
	return self;
end;
function Ridelle_AREvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.RidelleAR = streamReadBool(streamId);
	self:run(connection);
end;
function Ridelle_AREvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.RidelleAR);
end;
function Ridelle_AREvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:Ridelle_AR(self.RidelleAR, true);
	end;
end;
function Ridelle_AREvent.sendEvent(vehicle, RidelleAR, noEventSend)
	if RidelleAR ~= vehicle.RidelleAR then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(Ridelle_AREvent:new(vehicle, RidelleAR), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(Ridelle_AREvent:new(vehicle, RidelleAR));
			end;
		end;
	end;
end;